/*      Compiler: ECL 20.4.24                                         */
/*      Source: EXT:SERVE-EVENT;SERVE-EVENT.LISP                      */
#include <ecl/ecl-cmp.h>
#include "ext/serve-event.eclh"
/*      function definition for MAKE-HANDLER                          */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L1make_handler(cl_object v1descriptor, cl_object v2direction, cl_object v3function)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if ((cl_functionp(v3function))!=ECL_NIL) { goto L1; }
  si_structure_type_error(v3function, ECL_SYM("FUNCTION",398), VV[1], ECL_SYM("FUNCTION",398));
L1:;
  if (!(ecl_eql(v2direction,ECL_SYM("INPUT",1279)))) { goto L7; }
  goto L3;
  goto L5;
L7:;
  goto L5;
L5:;
  if (!(ecl_eql(v2direction,ECL_SYM("OUTPUT",1308)))) { goto L10; }
  goto L3;
  goto L4;
L10:;
  goto L4;
L4:;
  si_structure_type_error(v2direction, VV[5], VV[1], VV[6]);
L3:;
  value0 = si_make_structure(4, VV[7], v2direction, v1descriptor, v3function);
  return value0;
 }
}
/*      local function G14                                            */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC2__g14(cl_object v1, cl_object v2si__x)
{
 cl_object T0, T1, T2, T3;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4;
   v3 = cl_gensym(0);
   v4 = cl_gensym(0);
   T0 = cl_list(2, ECL_SYM("QUOTE",681), VV[1]);
   T1 = cl_list(6, ECL_SYM("COMPARE-AND-SWAP-STRUCTURE",1512), v2si__x, T0, ecl_make_fixnum(2), v3, v4);
   T2 = cl_list(2, ECL_SYM("QUOTE",681), VV[1]);
   T3 = cl_list(4, ECL_SYM("STRUCTURE-REF",1168), v2si__x, T2, ecl_make_fixnum(2));
   cl_env_copy->nvalues = 6;
   cl_env_copy->values[5] = T3;
   cl_env_copy->values[4] = T1;
   cl_env_copy->values[3] = v4;
   cl_env_copy->values[2] = v3;
   cl_env_copy->values[1] = ECL_NIL;
   cl_env_copy->values[0] = ECL_NIL;
   return cl_env_copy->values[0];
  }
 }
}
/*      local function G18                                            */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3__g18(cl_object v1, cl_object v2si__x)
{
 cl_object T0, T1, T2, T3;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4;
   v3 = cl_gensym(0);
   v4 = cl_gensym(0);
   T0 = cl_list(2, ECL_SYM("QUOTE",681), VV[1]);
   T1 = cl_list(6, ECL_SYM("COMPARE-AND-SWAP-STRUCTURE",1512), v2si__x, T0, ecl_make_fixnum(1), v3, v4);
   T2 = cl_list(2, ECL_SYM("QUOTE",681), VV[1]);
   T3 = cl_list(4, ECL_SYM("STRUCTURE-REF",1168), v2si__x, T2, ecl_make_fixnum(1));
   cl_env_copy->nvalues = 6;
   cl_env_copy->values[5] = T3;
   cl_env_copy->values[4] = T1;
   cl_env_copy->values[3] = v4;
   cl_env_copy->values[2] = v3;
   cl_env_copy->values[1] = ECL_NIL;
   cl_env_copy->values[0] = ECL_NIL;
   return cl_env_copy->values[0];
  }
 }
}
/*      local function G22                                            */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC4__g22(cl_object v1, cl_object v2si__x)
{
 cl_object T0, T1, T2, T3;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4;
   v3 = cl_gensym(0);
   v4 = cl_gensym(0);
   T0 = cl_list(2, ECL_SYM("QUOTE",681), VV[1]);
   T1 = cl_list(6, ECL_SYM("COMPARE-AND-SWAP-STRUCTURE",1512), v2si__x, T0, ecl_make_fixnum(0), v3, v4);
   T2 = cl_list(2, ECL_SYM("QUOTE",681), VV[1]);
   T3 = cl_list(4, ECL_SYM("STRUCTURE-REF",1168), v2si__x, T2, ecl_make_fixnum(0));
   cl_env_copy->nvalues = 6;
   cl_env_copy->values[5] = T3;
   cl_env_copy->values[4] = T1;
   cl_env_copy->values[3] = v4;
   cl_env_copy->values[2] = v3;
   cl_env_copy->values[1] = ECL_NIL;
   cl_env_copy->values[0] = ECL_NIL;
   return cl_env_copy->values[0];
  }
 }
}
/*      function definition for COERCE-TO-DESCRIPTOR                  */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L5coerce_to_descriptor(cl_object v1stream_or_fd, cl_object v2direction)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (!(ECL_FIXNUMP(v1stream_or_fd))) { goto L1; }
  value0 = v1stream_or_fd;
  cl_env_copy->nvalues = 1;
  return value0;
L1:;
  if (Null(si_of_class_p(2, v1stream_or_fd, ECL_SYM("FILE-STREAM",360)))) { goto L3; }
  value0 = si_file_stream_fd(v1stream_or_fd);
  return value0;
L3:;
  if (Null(si_of_class_p(2, v1stream_or_fd, ECL_SYM("TWO-WAY-STREAM",868)))) { goto L5; }
  if (!(ecl_eql(v2direction,ECL_SYM("INPUT",1279)))) { goto L9; }
  v1stream_or_fd = cl_two_way_stream_input_stream(v1stream_or_fd);
  goto L8;
L9:;
  if (!(ecl_eql(v2direction,ECL_SYM("OUTPUT",1308)))) { goto L11; }
  v1stream_or_fd = cl_two_way_stream_output_stream(v1stream_or_fd);
  goto L8;
L11:;
  v1stream_or_fd = ECL_NIL;
L8:;
  goto TTL;
L5:;
  if (Null(cl_streamp(v1stream_or_fd))) { goto L14; }
  value0 = ecl_function_dispatch(cl_env_copy,ECL_SYM("STREAM-FILE-DESCRIPTOR",1677))(2, v1stream_or_fd, v2direction) /*  STREAM-FILE-DESCRIPTOR */;
  return value0;
L14:;
  value0 = si_etypecase_error(v1stream_or_fd, VV[14]);
  return value0;
 }
}
/*      function definition for ADD-FD-HANDLER                        */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L6add_fd_handler(cl_object v1stream_or_fd, cl_object v2direction, cl_object v3function)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (!(ecl_eql(v2direction,ECL_SYM("INPUT",1279)))) { goto L5; }
  goto L1;
  goto L3;
L5:;
  goto L3;
L3:;
  if (!(ecl_eql(v2direction,ECL_SYM("OUTPUT",1308)))) { goto L8; }
  goto L1;
  goto L2;
L8:;
  goto L2;
L2:;
  T0 = ecl_list1(v2direction);
  cl_error(9, ECL_SYM("SIMPLE-TYPE-ERROR",775), ECL_SYM("FORMAT-CONTROL",1262), VV[16], ECL_SYM("FORMAT-ARGUMENTS",1261), T0, ECL_SYM("DATUM",1235), v2direction, ECL_SYM("EXPECTED-TYPE",1253), VV[5]);
L1:;
  {
   cl_object v4handler;
   T0 = L5coerce_to_descriptor(v1stream_or_fd, v2direction);
   v4handler = L1make_handler(T0, v2direction, v3function);
   cl_set(VV[13],CONS(v4handler,ecl_symbol_value(VV[13])));
   value0 = v4handler;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for REMOVE-FD-HANDLER                     */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L7remove_fd_handler(cl_object v1handler)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  cl_set(VV[13],cl_delete(2, v1handler, ecl_symbol_value(VV[13])));
  value0 = ecl_symbol_value(VV[13]);
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      local function WITH-FD-HANDLER                                */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC8with_fd_handler(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4, T5, T6;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4;
   cl_object v5;
   cl_object v6fd;
   cl_object v7direction;
   cl_object v8function;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v9;
    v9 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4 = v9;
   }
   v5 = v4;
   if (!(v5==ECL_NIL)) { goto L10; }
   si_dm_too_few_arguments(v1);
L10:;
   {
    cl_object v9;
    v9 = ecl_car(v5);
    v5 = ecl_cdr(v5);
    v6fd = v9;
   }
   if (!(v5==ECL_NIL)) { goto L16; }
   si_dm_too_few_arguments(v1);
L16:;
   {
    cl_object v9;
    v9 = ecl_car(v5);
    v5 = ecl_cdr(v5);
    v7direction = v9;
   }
   if (!(v5==ECL_NIL)) { goto L22; }
   si_dm_too_few_arguments(v1);
L22:;
   {
    cl_object v9;
    v9 = ecl_car(v5);
    v5 = ecl_cdr(v5);
    v8function = v9;
   }
   if (Null(v5)) { goto L27; }
   si_dm_too_many_arguments(v1);
L27:;
   {
    cl_object v9handler;
    v9handler = cl_gensym(0);
    T0 = ecl_list1(v9handler);
    T1 = cl_list(4, VV[17], v6fd, v7direction, v8function);
    T2 = cl_list(3, ECL_SYM("SETF",752), v9handler, T1);
    T3 = cl_listX(3, ECL_SYM("PROGN",673), T2, v3);
    T4 = cl_list(2, VV[18], v9handler);
    T5 = cl_list(3, ECL_SYM("WHEN",907), v9handler, T4);
    T6 = cl_list(3, ECL_SYM("UNWIND-PROTECT",890), T3, T5);
    value0 = cl_list(3, ECL_SYM("LET",479), T0, T6);
    return value0;
   }
  }
 }
}
/*      local function FD-ZERO                                        */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC9fd_zero(cl_object v1, cl_object v2)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4fdset;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4fdset = v5;
   }
   if (Null(v3)) { goto L8; }
   si_dm_too_many_arguments(v1);
L8:;
   T0 = ecl_list1(v4fdset);
   value0 = cl_listX(3, ECL_SYM("C-INLINE",2060), T0, VV[20]);
   return value0;
  }
 }
}
/*      local function FD-SET                                         */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC10fd_set(cl_object v1, cl_object v2)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4fd;
   cl_object v5fdset;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4fd = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5fdset = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   T0 = cl_list(2, v4fd, v5fdset);
   value0 = cl_listX(3, ECL_SYM("C-INLINE",2060), T0, VV[22]);
   return value0;
  }
 }
}
/*      local function FD-ISSET                                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC11fd_isset(cl_object v1, cl_object v2)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4fd;
   cl_object v5fdset;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   si_dm_too_few_arguments(v1);
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4fd = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   si_dm_too_few_arguments(v1);
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5fdset = v6;
   }
   if (Null(v3)) { goto L14; }
   si_dm_too_many_arguments(v1);
L14:;
   T0 = cl_list(2, v4fd, v5fdset);
   value0 = cl_listX(3, ECL_SYM("C-INLINE",2060), T0, VV[24]);
   return value0;
  }
 }
}
/*      function definition for FDSET-SIZE                            */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L12fdset_size()
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = ecl_make_int(sizeof(fd_set));
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for SERVE-EVENT                           */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L13serve_event(volatile cl_narg narg, ...)
{
 cl_object T0, T1;
 cl_object volatile env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object volatile value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg>1)) FEwrong_num_arguments_anonym();
 {
  cl_object volatile v1seconds;
  va_list args; va_start(args,narg);
  {
   int i = 0;
   if (i >= narg) {
    v1seconds = ECL_NIL;
   } else {
    i++;
    v1seconds = va_arg(args,cl_object);
   }
  }
  va_end(args);
  {
   volatile cl_object v2fsize;
   v2fsize = L12fdset_size();
   {
    volatile cl_object v3rfd;
    T0 = cl_list(3, ECL_SYM("ARRAY",1220), ECL_SYM("UNSIGNED-CHAR",1419), v2fsize);
    v3rfd = ecl_function_dispatch(cl_env_copy,ECL_SYM("ALLOCATE-FOREIGN-OBJECT",2058))(1, T0) /*  ALLOCATE-FOREIGN-OBJECT */;
    {
     struct ecl_stack_frame _ecl_inner_frame_aux;
     volatile cl_object _ecl_inner_frame = ecl_stack_frame_open(cl_env_copy,(cl_object)&_ecl_inner_frame_aux,0);
     {
      volatile cl_object v4;
      v4 = _ecl_inner_frame;
      {
       volatile cl_object v5;
       v5 = ecl_symbol_value(ECL_SYM("*INTERRUPTS-ENABLED*",7));
       ecl_bds_bind(cl_env_copy,ECL_SYM("*INTERRUPTS-ENABLED*",7),ECL_NIL); /*  *INTERRUPTS-ENABLED* */
       ecl_bds_bind(cl_env_copy,ECL_SYM("*ALLOW-WITH-INTERRUPTS*",1790),ECL_NIL); /*  *ALLOW-WITH-INTERRUPTS* */
       {
        volatile bool unwinding = FALSE;
        cl_index v6=ECL_STACK_INDEX(cl_env_copy),v7;
        ecl_frame_ptr next_fr;
        ecl_frs_push(cl_env_copy,ECL_PROTECT_TAG);
        if (__ecl_frs_push_result) {
          unwinding = TRUE; next_fr=cl_env_copy->nlj_fr;
        } else {
        ecl_bds_bind(cl_env_copy,ECL_SYM("*INTERRUPTS-ENABLED*",7),v5); /*  *INTERRUPTS-ENABLED* */
        {
         volatile cl_object v8wfd;
         T0 = cl_list(3, ECL_SYM("ARRAY",1220), ECL_SYM("UNSIGNED-CHAR",1419), v2fsize);
         v8wfd = ecl_function_dispatch(cl_env_copy,ECL_SYM("ALLOCATE-FOREIGN-OBJECT",2058))(1, T0) /*  ALLOCATE-FOREIGN-OBJECT */;
         {
          struct ecl_stack_frame _ecl_inner_frame_aux;
          volatile cl_object _ecl_inner_frame = ecl_stack_frame_open(cl_env_copy,(cl_object)&_ecl_inner_frame_aux,0);
          {
          volatile cl_object v9;
          v9 = _ecl_inner_frame;
          {
          volatile cl_object v10;
          v10 = ecl_symbol_value(ECL_SYM("*INTERRUPTS-ENABLED*",7));
          ecl_bds_bind(cl_env_copy,ECL_SYM("*INTERRUPTS-ENABLED*",7),ECL_NIL); /*  *INTERRUPTS-ENABLED* */
          ecl_bds_bind(cl_env_copy,ECL_SYM("*ALLOW-WITH-INTERRUPTS*",1790),ECL_NIL); /*  *ALLOW-WITH-INTERRUPTS* */
          {
          volatile bool unwinding = FALSE;
          cl_index v11=ECL_STACK_INDEX(cl_env_copy),v12;
          ecl_frame_ptr next_fr;
          ecl_frs_push(cl_env_copy,ECL_PROTECT_TAG);
          if (__ecl_frs_push_result) {
            unwinding = TRUE; next_fr=cl_env_copy->nlj_fr;
          } else {
          ecl_bds_bind(cl_env_copy,ECL_SYM("*INTERRUPTS-ENABLED*",7),v10); /*  *INTERRUPTS-ENABLED* */
          FD_ZERO((fd_set*)v3rfd->foreign.data);
          value0 = ECL_NIL;
          cl_env_copy->nvalues = 0;
          FD_ZERO((fd_set*)v8wfd->foreign.data);
          value0 = ECL_NIL;
          cl_env_copy->nvalues = 0;
          {
          cl_object v13maxfd;
          v13maxfd = ecl_make_fixnum(0);
          {
          cl_object v14;
          v14 = ecl_symbol_value(VV[13]);
          goto L24;
L23:;
          {
          cl_object v15handler;
          v15handler = ecl_car(v14);
          {
          cl_object v16fd;
          v16fd = ecl_function_dispatch(cl_env_copy,VV[11])(1, v15handler) /*  HANDLER-DESCRIPTOR */;
          {
          cl_object v17;
          v17 = ecl_function_dispatch(cl_env_copy,VV[12])(1, v15handler) /*  HANDLER-DIRECTION */;
          if (!(ecl_eql(v17,ECL_SYM("INPUT",1279)))) { goto L32; }
          FD_SET(ecl_to_int(v16fd), (fd_set*)v3rfd->foreign.data);;
          value0 = ECL_NIL;
          cl_env_copy->nvalues = 0;
          goto L30;
L32:;
          if (!(ecl_eql(v17,ECL_SYM("OUTPUT",1308)))) { goto L34; }
          FD_SET(ecl_to_int(v16fd), (fd_set*)v8wfd->foreign.data);;
          value0 = ECL_NIL;
          cl_env_copy->nvalues = 0;
          goto L30;
L34:;
          si_ecase_error(v17, VV[3]);
          }
L30:;
          if (!(ecl_greater(v16fd,v13maxfd))) { goto L28; }
          v13maxfd = v16fd;
          }
L28:;
          }
          v14 = ecl_cdr(v14);
L24:;
          if (Null(v14)) { goto L40; }
          goto L23;
L40:;
          }
          {
          cl_object v15;                          /*  RETVAL          */
          cl_object v16;                          /*  ERRNO           */
          if (!(v1seconds==ECL_NIL)) { goto L43; }
          T0 = ecl_one_plus(v13maxfd);
          {
          int v17;
          int v18;
          { v17= select(ecl_to_int(T0), (fd_set*)v3rfd->foreign.data,
                                                      (fd_set*)v8wfd->foreign.data,
                                                      NULL, NULL);
                             v18= errno; }
          cl_env_copy->values[0] = ecl_make_int(v17);
          cl_env_copy->values[1] = ecl_make_int(v18);cl_env_copy->nvalues = 2;
          value0 = cl_env_copy->values[0];
          goto L42;
          }
L43:;
          T0 = ecl_one_plus(v13maxfd);
          {
          int v19;
          int v20;
          { struct timeval tv;
                             double seconds = ecl_to_double(v1seconds);
                                tv.tv_sec = seconds;
                                tv.tv_usec = (seconds * 1e6);
                                v19= select(ecl_to_int(T0), (fd_set*)v3rfd->foreign.data,
                                                         (fd_set*)v8wfd->foreign.data,
                                                         NULL, &tv);
                                v20= errno; }
          cl_env_copy->values[0] = ecl_make_int(v19);
          cl_env_copy->values[1] = ecl_make_int(v20);cl_env_copy->nvalues = 2;
          value0 = cl_env_copy->values[0];
          }
L42:;
          v15 = value0;
          v16 = cl_env_copy->values[1];
          if (!(ecl_zerop(v15))) { goto L45; }
          cl_env_copy->values[0] = ECL_NIL;
          cl_env_copy->nvalues = 1;
          ecl_bds_unwind1(cl_env_copy);
          goto L16;
L45:;
          if (!(ecl_minusp(v15))) { goto L47; }
          if (!(ecl_number_equalp(v16,ecl_symbol_value(VV[0])))) { goto L49; }
          cl_env_copy->values[0] = ECL_NIL;
          cl_env_copy->nvalues = 1;
          ecl_bds_unwind1(cl_env_copy);
          goto L16;
L49:;
          cl_env_copy->values[0] = cl_error(1, VV[27]);
          ecl_bds_unwind1(cl_env_copy);
          goto L16;
L47:;
          if (!(ecl_plusp(v15))) { goto L51; }
          {
          cl_object v17;
          v17 = ecl_symbol_value(VV[13]);
          goto L57;
L56:;
          {
          cl_object v18handler;
          v18handler = ecl_car(v17);
          {
          cl_object v19fd;
          v19fd = ecl_function_dispatch(cl_env_copy,VV[11])(1, v18handler) /*  HANDLER-DESCRIPTOR */;
          {
          cl_object v20;
          v20 = ecl_function_dispatch(cl_env_copy,VV[12])(1, v18handler) /*  HANDLER-DIRECTION */;
          if (!(ecl_eql(v20,ECL_SYM("INPUT",1279)))) { goto L66; }
          T0 = ecl_make_int(FD_ISSET(ecl_to_int(v19fd), (fd_set*)v3rfd->foreign.data));
          goto L64;
L66:;
          if (!(ecl_eql(v20,ECL_SYM("OUTPUT",1308)))) { goto L68; }
          T0 = ecl_make_int(FD_ISSET(ecl_to_int(v19fd), (fd_set*)v8wfd->foreign.data));
          goto L64;
L68:;
          T0 = si_ecase_error(v20, VV[3]);
          }
L64:;
          if (!(ecl_plusp(T0))) { goto L61; }
          T0 = ecl_function_dispatch(cl_env_copy,VV[9])(1, v18handler) /*  HANDLER-FUNCTION */;
          T1 = ecl_function_dispatch(cl_env_copy,VV[11])(1, v18handler) /*  HANDLER-DESCRIPTOR */;
          ecl_function_dispatch(cl_env_copy,T0)(1, T1);
          }
L61:;
          }
          v17 = ecl_cdr(v17);
L57:;
          if (Null(v17)) { goto L73; }
          goto L56;
L73:;
          }
          cl_env_copy->values[0] = ECL_T;
          cl_env_copy->nvalues = 1;
          ecl_bds_unwind1(cl_env_copy);
          goto L16;
L51:;
          cl_env_copy->values[0] = ECL_NIL;
          cl_env_copy->nvalues = 1;
          ecl_bds_unwind1(cl_env_copy);
          }
          }
L16:;
            next_fr = NULL;
          }
          ecl_frs_pop(cl_env_copy);
          v12=ecl_stack_push_values(cl_env_copy);
          ecl_function_dispatch(cl_env_copy,ECL_SYM("FREE-FOREIGN-OBJECT",2094))(1, v8wfd) /*  FREE-FOREIGN-OBJECT */;
          ecl_stack_pop_values(cl_env_copy,v12);
          if (unwinding) ecl_unwind(cl_env_copy,next_fr);
          ECL_STACK_SET_INDEX(cl_env_copy,v11);
          ecl_bds_unwind1(cl_env_copy);
          ecl_bds_unwind1(cl_env_copy);
          }
          }
          ecl_stack_frame_push_values(v9);
          value0 = ECL_NIL;
          cl_env_copy->nvalues = 0;
          if (Null(ecl_symbol_value(ECL_SYM("*INTERRUPTS-ENABLED*",7)))) { goto L76; }
          si_check_pending_interrupts();
L76:;cl_env_copy->values[0]=ecl_stack_frame_pop_values(v9);
          }
          ecl_stack_frame_close(_ecl_inner_frame);
         }
         ecl_bds_unwind1(cl_env_copy);
        }
          next_fr = NULL;
        }
        ecl_frs_pop(cl_env_copy);
        v7=ecl_stack_push_values(cl_env_copy);
        ecl_function_dispatch(cl_env_copy,ECL_SYM("FREE-FOREIGN-OBJECT",2094))(1, v3rfd) /*  FREE-FOREIGN-OBJECT */;
        ecl_stack_pop_values(cl_env_copy,v7);
        if (unwinding) ecl_unwind(cl_env_copy,next_fr);
        ECL_STACK_SET_INDEX(cl_env_copy,v6);
        ecl_bds_unwind1(cl_env_copy);
        ecl_bds_unwind1(cl_env_copy);
       }
      }
      ecl_stack_frame_push_values(v4);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      if (Null(ecl_symbol_value(ECL_SYM("*INTERRUPTS-ENABLED*",7)))) { goto L79; }
      si_check_pending_interrupts();
L79:;cl_env_copy->values[0]=ecl_stack_frame_pop_values(v4);
      value0 = cl_env_copy->values[0];
     }
     ecl_stack_frame_close(_ecl_inner_frame);
    }
    return value0;
   }
  }
 }
}
/*      function definition for SERVE-ALL-EVENTS                      */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L14serve_all_events(cl_narg narg, ...)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg>1)) FEwrong_num_arguments_anonym();
 {
  cl_object v1timeout;
  va_list args; va_start(args,narg);
  {
   int i = 0;
   if (i >= narg) {
    v1timeout = ECL_NIL;
   } else {
    i++;
    v1timeout = va_arg(args,cl_object);
   }
  }
  va_end(args);
  {
   cl_object v2;
   cl_object v3res;
   cl_object v4sval;
   v2 = L13serve_event(1, v1timeout);
   v3res = ECL_NIL;
   v4sval = v2;
   goto L7;
L6:;
   v3res = ECL_T;
   v4sval = L13serve_event(1, ecl_make_fixnum(0));
L7:;
   if (v4sval==ECL_NIL) { goto L13; }
   goto L6;
L13:;
   value0 = v3res;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}

#include "ext/serve-event.data"
#ifdef __cplusplus
extern "C"
#endif
ECL_DLLEXPORT void _eclqZIWPfb7_FqyqAz41(cl_object flag)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 cl_object *VVtemp;
 if (flag != OBJNULL){
 Cblock = flag;
 #ifndef ECL_DYNAMIC_VV
 flag->cblock.data = VV;
 #endif
 flag->cblock.data_size = VM;
 flag->cblock.temp_data_size = VMtemp;
 flag->cblock.data_text = compiler_data_text;
 flag->cblock.cfuns_size = compiler_cfuns_size;
 flag->cblock.cfuns = compiler_cfuns;
 flag->cblock.source = ecl_make_constant_base_string("EXT:SERVE-EVENT;SERVE-EVENT.LISP.NEWEST",-1);
 return;}
 #ifdef ECL_DYNAMIC_VV
 VV = Cblock->cblock.data;
 #endif
 Cblock->cblock.data_text = (const cl_object *)"@EcLtAg:_eclqZIWPfb7_FqyqAz41@";
 VVtemp = Cblock->cblock.temp_data;
 ECL_DEFINE_SETF_FUNCTIONS
  ecl_function_dispatch(cl_env_copy,VV[31])(12, VVtemp[0], ECL_NIL, ECL_NIL, ECL_NIL, VVtemp[1], ECL_NIL, ECL_NIL, ECL_NIL, VVtemp[2], ECL_NIL, ECL_NIL, ECL_NIL) /*  DODEFPACKAGE */;
  si_select_package(VVtemp[0]);
  {
   int v1;
   v1 = EINTR;
   si_Xmake_constant(VV[0], ecl_make_int(v1));
  }
 {
  cl_object T0;
  cl_object volatile env0 = ECL_NIL;
  si_define_structure(VV[1], _ecl_static_0, ECL_NIL, ECL_NIL, VVtemp[3], VVtemp[4], ECL_NIL, ECL_NIL, ECL_NIL, ECL_NIL, VVtemp[5], ecl_make_fixnum(3), ECL_NIL, ECL_NIL, VV[2]);
  VV[7]= cl_find_class(1, VV[1]);
  ecl_cmp_defun(VV[32]);                          /*  MAKE-HANDLER    */
  {
   cl_object v1package;
   v1package = cl_symbol_package(VV[9]);
   if (Null(v1package)) { goto L18; }
   if (Null(si_package_locked_p(v1package))) { goto L18; }
   if (!(ecl_symbol_value(ECL_SYM("*IGNORE-PACKAGE-LOCKS*",1118))==ECL_NIL)) { goto L18; }
   si_signal_simple_error(6, ECL_SYM("PACKAGE-ERROR",620), VVtemp[6], VVtemp[7], VVtemp[8], ECL_SYM("PACKAGE",1310), v1package);
  }
L18:;
  {
   cl_object volatile v2;
   v2 = ecl_make_cfun((cl_objectfn_fixed)LC2__g14,ECL_NIL,Cblock,2);
   T0 = v2;
  }
  si_put_sysprop(VV[9], VV[10], T0);
  {
   cl_object v2package;
   v2package = cl_symbol_package(VV[11]);
   if (Null(v2package)) { goto L26; }
   if (Null(si_package_locked_p(v2package))) { goto L26; }
   if (!(ecl_symbol_value(ECL_SYM("*IGNORE-PACKAGE-LOCKS*",1118))==ECL_NIL)) { goto L26; }
   si_signal_simple_error(6, ECL_SYM("PACKAGE-ERROR",620), VVtemp[6], VVtemp[7], VVtemp[9], ECL_SYM("PACKAGE",1310), v2package);
  }
L26:;
  {
   cl_object volatile v3;
   v3 = ecl_make_cfun((cl_objectfn_fixed)LC3__g18,ECL_NIL,Cblock,2);
   T0 = v3;
  }
  si_put_sysprop(VV[11], VV[10], T0);
  {
   cl_object v3package;
   v3package = cl_symbol_package(VV[12]);
   if (Null(v3package)) { goto L34; }
   if (Null(si_package_locked_p(v3package))) { goto L34; }
   if (!(ecl_symbol_value(ECL_SYM("*IGNORE-PACKAGE-LOCKS*",1118))==ECL_NIL)) { goto L34; }
   si_signal_simple_error(6, ECL_SYM("PACKAGE-ERROR",620), VVtemp[6], VVtemp[7], VVtemp[10], ECL_SYM("PACKAGE",1310), v3package);
  }
L34:;
  {
   cl_object volatile v4;
   v4 = ecl_make_cfun((cl_objectfn_fixed)LC4__g22,ECL_NIL,Cblock,2);
   T0 = v4;
  }
  si_put_sysprop(VV[12], VV[10], T0);
 }
  si_Xmake_special(VV[13]);
  if (ecl_boundp(cl_env_copy,VV[13])) { goto L44; }
  cl_set(VV[13],ECL_NIL);
L44:;
  ecl_cmp_defun(VV[33]);                          /*  COERCE-TO-DESCRIPTOR */
  ecl_cmp_defun(VV[34]);                          /*  ADD-FD-HANDLER  */
  ecl_cmp_defun(VV[35]);                          /*  REMOVE-FD-HANDLER */
  ecl_cmp_defmacro(VV[36]);                       /*  WITH-FD-HANDLER */
  ecl_cmp_defmacro(VV[37]);                       /*  FD-ZERO         */
  ecl_cmp_defmacro(VV[38]);                       /*  FD-SET          */
  ecl_cmp_defmacro(VV[39]);                       /*  FD-ISSET        */
  ecl_cmp_defun(VV[40]);                          /*  FDSET-SIZE      */
  ecl_cmp_defun(VV[41]);                          /*  SERVE-EVENT     */
  ecl_cmp_defun(VV[42]);                          /*  SERVE-ALL-EVENTS */
  cl_provide(VV[30]);
}
